using Microsoft.Ink;
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.Windows.Ink;

namespace InkReco
{
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Panel panel1;
		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.Button button2;
        private System.Windows.Forms.Button button3;
        private System.Windows.Forms.Button button4;
        private System.Windows.Forms.Button button5;
        private System.Windows.Forms.Button button6;
        private System.Windows.Forms.Button button7;
        private System.Windows.Forms.Button button8;
        private System.Windows.Forms.Button button9;
        private System.Windows.Forms.Button button10;
        private System.Windows.Forms.Button button11;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.ComboBox comboBox1;
        private System.Windows.Forms.Button button12;

        private InkOverlay collector;

		public Form1()
		{
			InitializeComponent();

            this.comboBox1.SelectedIndex = 0;

            this.collector = new InkOverlay(this.panel1);
            this.collector.CollectionMode = CollectionMode.InkAndGesture;
            this.collector.SetGestureStatus(ApplicationGesture.Scratchout,true);
            this.collector.Gesture +=new InkCollectorGestureEventHandler(collector_Gesture);
            this.collector.Enabled = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.panel1 = new System.Windows.Forms.Panel();
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.button3 = new System.Windows.Forms.Button();
            this.button4 = new System.Windows.Forms.Button();
            this.button5 = new System.Windows.Forms.Button();
            this.button6 = new System.Windows.Forms.Button();
            this.button7 = new System.Windows.Forms.Button();
            this.button8 = new System.Windows.Forms.Button();
            this.button9 = new System.Windows.Forms.Button();
            this.button10 = new System.Windows.Forms.Button();
            this.button11 = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.button12 = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.panel1.BackColor = System.Drawing.Color.White;
            this.panel1.Location = new System.Drawing.Point(8, 64);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(584, 456);
            this.panel1.TabIndex = 0;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(8, 4);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(88, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "Simple Reco";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(104, 4);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(88, 23);
            this.button2.TabIndex = 2;
            this.button2.Text = "Manual Reco";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // button3
            // 
            this.button3.Location = new System.Drawing.Point(192, 4);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(80, 23);
            this.button3.TabIndex = 3;
            this.button3.Text = "All Matches";
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // button4
            // 
            this.button4.Location = new System.Drawing.Point(272, 4);
            this.button4.Name = "button4";
            this.button4.Size = new System.Drawing.Size(88, 23);
            this.button4.TabIndex = 4;
            this.button4.Text = "Find Baseline";
            this.button4.Click += new System.EventHandler(this.button4_Click);
            // 
            // button5
            // 
            this.button5.Location = new System.Drawing.Point(104, 32);
            this.button5.Name = "button5";
            this.button5.Size = new System.Drawing.Size(72, 23);
            this.button5.TabIndex = 5;
            this.button5.Text = "Email Reco";
            this.button5.Click += new System.EventHandler(this.button5_Click);
            // 
            // button6
            // 
            this.button6.Location = new System.Drawing.Point(176, 32);
            this.button6.Name = "button6";
            this.button6.Size = new System.Drawing.Size(64, 23);
            this.button6.TabIndex = 6;
            this.button6.Text = "Word List";
            this.button6.Click += new System.EventHandler(this.button6_Click);
            // 
            // button7
            // 
            this.button7.Location = new System.Drawing.Point(304, 32);
            this.button7.Name = "button7";
            this.button7.Size = new System.Drawing.Size(56, 23);
            this.button7.TabIndex = 7;
            this.button7.Text = "Async";
            this.button7.Click += new System.EventHandler(this.button7_Click);
            // 
            // button8
            // 
            this.button8.Location = new System.Drawing.Point(368, 4);
            this.button8.Name = "button8";
            this.button8.Size = new System.Drawing.Size(56, 23);
            this.button8.TabIndex = 8;
            this.button8.Text = "Divide";
            this.button8.Click += new System.EventHandler(this.button8_Click);
            // 
            // button9
            // 
            this.button9.Location = new System.Drawing.Point(432, 4);
            this.button9.Name = "button9";
            this.button9.Size = new System.Drawing.Size(56, 23);
            this.button9.TabIndex = 9;
            this.button9.Text = "Analyze";
            this.button9.Click += new System.EventHandler(this.button9_Click);
            // 
            // button10
            // 
            this.button10.Location = new System.Drawing.Point(488, 4);
            this.button10.Name = "button10";
            this.button10.Size = new System.Drawing.Size(104, 23);
            this.button10.TabIndex = 10;
            this.button10.Text = "Analyze List";
            this.button10.Click += new System.EventHandler(this.button10_Click);
            // 
            // button11
            // 
            this.button11.Location = new System.Drawing.Point(488, 32);
            this.button11.Name = "button11";
            this.button11.Size = new System.Drawing.Size(104, 23);
            this.button11.TabIndex = 11;
            this.button11.Text = "Analyze Drawing";
            this.button11.Click += new System.EventHandler(this.button11_Click);
            // 
            // label1
            // 
            this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label1.Location = new System.Drawing.Point(8, 528);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(40, 16);
            this.label1.TabIndex = 12;
            this.label1.Text = "Mode:";
            // 
            // comboBox1
            // 
            this.comboBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox1.Items.AddRange(new object[] {
                                                           "Ink",
                                                           "Select",
                                                           "Erase"});
            this.comboBox1.Location = new System.Drawing.Point(56, 525);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(80, 21);
            this.comboBox1.TabIndex = 13;
            this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
            // 
            // button12
            // 
            this.button12.Location = new System.Drawing.Point(432, 32);
            this.button12.Name = "button12";
            this.button12.Size = new System.Drawing.Size(56, 23);
            this.button12.TabIndex = 14;
            this.button12.Text = "Links";
            this.button12.Click += new System.EventHandler(this.button12_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(600, 550);
            this.Controls.Add(this.button12);
            this.Controls.Add(this.comboBox1);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.button11);
            this.Controls.Add(this.button10);
            this.Controls.Add(this.button9);
            this.Controls.Add(this.button8);
            this.Controls.Add(this.button7);
            this.Controls.Add(this.button6);
            this.Controls.Add(this.button5);
            this.Controls.Add(this.button4);
            this.Controls.Add(this.button3);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.panel1);
            this.Name = "Form1";
            this.Text = "Ink Recognition and Analysis";
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void button1_Click(object sender, System.EventArgs e)
        {
            string result = this.collector.Ink.Strokes.ToString();
            MessageBox.Show(result);
        }

        private void button2_Click(object sender, System.EventArgs e)
        {
            Recognizers recs = new Recognizers();
            Recognizer reco = recs.GetDefaultRecognizer();
            //RecognizerContext context = new RecognizerContext();
            RecognizerContext context = reco.CreateRecognizerContext();
            context.Strokes = this.collector.Ink.Strokes;
            RecognitionStatus status = RecognitionStatus.NoError;
            RecognitionResult result = context.Recognize(out status);
            if (status == RecognitionStatus.NoError)
            {
                MessageBox.Show(result.TopAlternate.ToString());
            }
            context.Dispose();
        }

        private void button3_Click(object sender, System.EventArgs e)
        {
            RecognizerContext context = new RecognizerContext();
            context.Strokes = this.collector.Ink.Strokes;
            RecognitionStatus status = RecognitionStatus.NoError;
            RecognitionResult res = context.Recognize(out status);
            if (status == RecognitionStatus.NoError)
            {
                string text = "Possible Matches:\r\n\r\n";
                foreach(RecognitionAlternate alt in res.GetAlternatesFromSelection())
                {
                    text += alt.ToString() + "   [" + alt.Confidence.ToString() + "]\r\n";
                }
                MessageBox.Show(text);
            }
            context.Dispose();
        }

        private void button4_Click(object sender, System.EventArgs e)
        {
            RecognizerContext context = new RecognizerContext();
            context.Strokes = this.collector.Ink.Strokes;
            RecognitionStatus status = RecognitionStatus.NoError;
            RecognitionResult res = context.Recognize(out status);
            if (status == RecognitionStatus.NoError)
            {
                Line bl = res.TopAlternate.Baseline;
                Graphics g = this.panel1.CreateGraphics();
                Renderer rend = this.collector.Renderer;

                Point p1 = bl.BeginPoint;
                Point p2 = bl.EndPoint;
                rend.InkSpaceToPixel(g,ref p1);
                rend.InkSpaceToPixel(g,ref p2);

                g.DrawLine(Pens.Red,p1,p2);
            }
            context.Dispose();
        }

        private void button5_Click(object sender, System.EventArgs e)
        {
            RecognizerContext context = new RecognizerContext();
            context.Factoid = Factoid.Email + "|" + Factoid.Web;
            context.Strokes = this.collector.Ink.Strokes;
            RecognitionStatus status = RecognitionStatus.NoError;
            RecognitionResult result = context.Recognize(out status);
            if (status == RecognitionStatus.NoError)
            {
                MessageBox.Show(result.TopAlternate.ToString());
            }
            context.Dispose();
        }

        private void button6_Click(object sender, System.EventArgs e)
        {
            RecognizerContext context = new RecognizerContext();
            WordList lst = new WordList();
            lst.Add("hail");
            lst.Add("damage");
            lst.Add("car");
            lst.Add("crash");
            context.WordList = lst;
            context.Factoid = Factoid.WordList;
            context.Strokes = this.collector.Ink.Strokes;
            RecognitionStatus status = RecognitionStatus.NoError;
            RecognitionResult result = context.Recognize(out status);
            if (status == RecognitionStatus.NoError)
            {
                MessageBox.Show(result.TopAlternate.ToString());
            }
            context.Dispose();
        }

        private RecognizerContext myContext;
        private Strokes myStrokes;

        private void button7_Click(object sender, System.EventArgs e)
        {
            this.myContext = new RecognizerContext();
            this.myStrokes = this.collector.Ink.Strokes;
            this.myContext.Strokes = this.myStrokes;
            this.collector.Stroke += new InkCollectorStrokeEventHandler(collector_Stroke);
            this.myContext.Recognition += new RecognizerContextRecognitionEventHandler(context_Recognition);
        }

        private void collector_Stroke(object sender, InkCollectorStrokeEventArgs e)
        {
            this.myStrokes.Add(e.Stroke);
            this.myContext.BackgroundRecognize();
        }

        private void context_Recognition(object sender, RecognizerContextRecognitionEventArgs e)
        {
            this.Text = e.Text;
        }

        private void collector_Gesture(object sender, InkCollectorGestureEventArgs e)
        {
            if (e.Gestures[0].Id == ApplicationGesture.Scratchout)
            {
                if (e.Gestures[0].Confidence == RecognitionConfidence.Intermediate ||
                    e.Gestures[0].Confidence == RecognitionConfidence.Strong)
                {
                    // Get the dimensions of the scratch-out area
                    Rectangle scratchRect = e.Strokes.GetBoundingBox();
                    // Find the existing strokes that overlap at least
                    // 60% with that area
                    Strokes deleteStrokes = this.collector.Ink.HitTest(scratchRect,60);

                    // If we found anything, we know we have a scratch-out
                    // and delete the affected strokes
                    if (deleteStrokes.Count > 0)
                    {
                        // The strokes used for the scratch-out
                        // should not be handled any further
                        e.Cancel = true;

                        // Get rid of the affected strokes 
                        this.collector.Ink.DeleteStrokes(deleteStrokes);
                        // We also do not want the new strokes
                        // created by the scratch-out
                        this.collector.Ink.DeleteStrokes(e.Strokes);
                        
                        this.Refresh();
                    }
                }
            }
        }

        private void button8_Click(object sender, System.EventArgs e)
        {
            Graphics g = this.panel1.CreateGraphics();
            Renderer rend = this.collector.Renderer;

            Divider div = new Divider(this.collector.Ink.Strokes);
            DivisionResult res = div.Divide();

            // Paragraphs
            DivisionUnits paras = res.ResultByType(InkDivisionType.Paragraph);
            foreach(DivisionUnit para in paras)
            {
                Rectangle rect1 = para.Strokes.GetBoundingBox();
                Point p1 = new Point(rect1.Left,rect1.Top);
                Point p2 = new Point(rect1.Width,rect1.Height);
                rend.InkSpaceToPixel(g,ref p1);
                rend.InkSpaceToPixel(g,ref p2);
                g.DrawRectangle(Pens.Blue,p1.X-2,p1.Y-2,p2.X+4,p2.Y+4);
            }

            // Lines
            DivisionUnits lines = res.ResultByType(InkDivisionType.Line);
            foreach(DivisionUnit line in lines)
            {
                Rectangle rect1 = line.Strokes.GetBoundingBox();
                Point p1 = new Point(rect1.Left,rect1.Top);
                Point p2 = new Point(rect1.Width,rect1.Height);
                rend.InkSpaceToPixel(g,ref p1);
                rend.InkSpaceToPixel(g,ref p2);
                g.DrawRectangle(Pens.Green,p1.X,p1.Y,p2.X,p2.Y);
            }

            // Segments
            DivisionUnits segments = res.ResultByType(InkDivisionType.Segment);
            foreach(DivisionUnit segment in segments)
            {
                Rectangle rect1 = segment.Strokes.GetBoundingBox();
                Point p1 = new Point(rect1.Left,rect1.Top);
                Point p2 = new Point(rect1.Width,rect1.Height);
                rend.InkSpaceToPixel(g,ref p1);
                rend.InkSpaceToPixel(g,ref p2);
                g.DrawRectangle(Pens.Yellow,p1.X+2,p1.Y+2,p2.X-4,p2.Y-4);
            }
        }

        private void button9_Click(object sender, System.EventArgs e)
        {
            InkAnalyzer analyzer = new InkAnalyzer(this.collector.Ink,this);
            analyzer.AddStrokes(this.collector.Ink.Strokes);
            analyzer.Analyze();
            StringBuilder sb = new StringBuilder();
            this.ExploreNode(analyzer.RootNode,sb,0);
            MessageBox.Show(sb.ToString());
        }

        private void ExploreNode(ContextNode node, StringBuilder sb, int indent)
        {
            sb.Append(string.Empty.PadLeft(indent*4,' '));
            sb.Append(node.GetType().ToString() + "  ");
            sb.Append("["+node.Strokes.ToString()+"]");
            sb.Append("\r\n");
            foreach(ContextNode subNode in node.SubNodes)
            {
                this.ExploreNode(subNode,sb,indent+1);
            }
        }

        private void button10_Click(object sender, System.EventArgs e)
        {
            InkAnalyzer analyzer = new Microsoft.Ink.InkAnalyzer(this.collector.Ink,this);
            analyzer.AddStrokes(this.collector.Ink.Strokes);
            analyzer.Analyze();
            ContextNodeCollection bullets = analyzer.FindNodesOfType(System.Windows.Ink.ContextNodeType.InkBullet);
            string bulletString = string.Empty;
            foreach(InkBulletNode bullet in bullets)
            {
                bulletString += bullet.Strokes.ToString();
            }
            MessageBox.Show(bulletString);
        }

        private void button11_Click(object sender, System.EventArgs e)
        {
            InkAnalyzer analyzer = new Microsoft.Ink.InkAnalyzer(this.collector.Ink,this);
            analyzer.AddStrokes(this.collector.Ink.Strokes);
            analyzer.Analyze();
            ContextNodeCollection drawings = analyzer.FindNodesOfType(System.Windows.Ink.ContextNodeType.InkDrawing);
            string drawingString = "You drew:\r\n\r\n";
            foreach(InkDrawingNode drawing in drawings)
            {
                drawingString += drawing.GetShapeName() + "\r\n";
            }
            MessageBox.Show(drawingString);
        }

        private void comboBox1_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (!this.IsHandleCreated)
            {
                return;
            }
            switch (this.comboBox1.SelectedIndex)
            {
                case 0:
                    this.collector.EditingMode = InkOverlayEditingMode.Ink;
                    break;
                case 1:
                    this.collector.EditingMode = InkOverlayEditingMode.Select;
                    break;
                case 2:
                    this.collector.EditingMode = InkOverlayEditingMode.Delete;
                    break;
            }
        }

        private void button12_Click(object sender, System.EventArgs e)
        {
            InkAnalyzer analyzer = new InkAnalyzer(this.collector.Ink,this);
            analyzer.AddStrokes(this.collector.Ink.Strokes);
            analyzer.Analyze();
            this.ShowLinks(analyzer.RootNode);
            this.Refresh();
        }

        private void ShowLinks(ContextNode node)
        {
            if (node.Links.Count > 0)
            {
                node.Strokes.ModifyDrawingAttributes(new DrawingAttributes(Color.Blue));
                foreach(ContextLink link in node.Links)
                {
                    link.SourceNode.Strokes.ModifyDrawingAttributes(new DrawingAttributes(Color.Green));
                    link.DestinationNode.Strokes.ModifyDrawingAttributes(new DrawingAttributes(Color.Red));
                }
            }
            foreach(ContextNode subNode in node.SubNodes)
            {
                this.ShowLinks(subNode);
            }
        }
    }
}
